/*---------------------------------------------------------------------------------------------------------*/
/*                                                                                                         */
/* Copyright(c) 2009 Nuvoton Technology Corp. All rights reserved.                                         */
/* Writed by Nuvoton(SH) CF10.   2013/02/25                                                                                                        */
/*---------------------------------------------------------------------------------------------------------*/
#include <stdio.h>
#include "NUC1xx.h"
#include "DrvGPIO.h"
#include "DrvFMC.h"
#include "DrvSYS.h"
#include "DrvPWM.h"
#include "DrvADC.h"
#include "DrvTIMER.h"
/*---------------------------------------------------------------------------------------------------------*/
/* Define functions prototype                                                                              */
/*---------------------------------------------------------------------------------------------------------*/

void TMR0_Callback(uint32_t u32Param)
{	
	GPIOC->DOUT ^= (1 << 3);          //ʱжȡIO    
}


void CalPeriodTime(uint8_t u8Capture)
{
    uint16_t u32Count[4];
    uint32_t u32i;
    uint16_t u16RisingTime, u16FallingTime, u16HighPeroid, u16LowPeroid, u16TotalPeroid;
    
    /* Clear the Capture Interrupt Flag  */
    DrvPWM_ClearCaptureIntStatus(u8Capture, DRVPWM_CAP_FALLING_FLAG);
    
    /* Wait for Interrupt Flag  (Falling) */
    while (DrvPWM_GetCaptureIntStatus(u8Capture, DRVPWM_CAP_FALLING_FLAG) != 1);
    
    /* Clear the Capture Interrupt Flag */
    DrvPWM_ClearCaptureIntStatus(u8Capture, DRVPWM_CAP_FALLING_FLAG);
    
    u32i = 0;
    
    while (u32i < 4)
    {
        /* Wait for Interrupt Flag (Falling) */
        while(DrvPWM_GetCaptureIntStatus(u8Capture, DRVPWM_CAP_FALLING_FLAG) != 1);

        /* Clear the Capture Interrupt Flag */
        DrvPWM_ClearCaptureIntStatus(u8Capture, DRVPWM_CAP_FALLING_FLAG);

        /* Clear the Capture Rising Interrupt Flag */
        DrvPWM_ClearCaptureIntStatus(u8Capture, DRVPWM_CAP_RISING_FLAG);
                
        /* Get the Falling Counter Data */
        u32Count[u32i++] = DrvPWM_GetFallingCounter(u8Capture);
        
        /* Wait for Capture Rising Interrupt Flag */
        while(DrvPWM_GetCaptureIntStatus(u8Capture, DRVPWM_CAP_RISING_FLAG) != 1);
        
        /* Clear the Capture Rising Interrupt Flag */
        DrvPWM_ClearCaptureIntStatus(u8Capture, DRVPWM_CAP_RISING_FLAG);
        
        /* Get the Rising Counter Data */
        u32Count[u32i++] = DrvPWM_GetRisingCounter(u8Capture);
    }   
    //Ϊʹ½жϣ½ػḴλֵزḴλ
    u16RisingTime = u32Count[1];   //⵽ʱֵ  
    
    u16FallingTime = u32Count[0];  //⵽½ʱֵ   
    
    u16HighPeroid = u32Count[1] - u32Count[2]; //ߵƽʱ
    
    u16LowPeroid = 0x10000 - u32Count[1];      //͵ƽʱ
    
    u16TotalPeroid = 0x10000 - u32Count[2];    //ʱ
        
    printf("Capture Test Result:\nRising Time = %d, Falling Time = %d.\nHigh Period = %d, Low  Period = %d, Total Period = %d.\n\n",
        u16RisingTime, u16FallingTime, u16HighPeroid, u16LowPeroid, u16TotalPeroid);
}


void Test_TIMER(void)
{	
    DrvTIMER_Init();
		DrvTIMER_Open(E_TMR0, 4, E_PERIODIC_MODE);  //öʱΪģʽ
		DrvTIMER_SetTimerEvent(E_TMR0, 2, (TIMER_CALLBACK)TMR0_Callback, 1);//ÿж
		DrvTIMER_EnableInt(E_TMR0);    //ʹܶʱж
		DrvTIMER_Start(E_TMR0);         
}	

void Test_PWM_CAP(void)     //ҪPWM0PWM3һ
{	
	  uint8_t u8Timer, u8CapTimer; 
	  S_DRVPWM_TIME_DATA_T sPt;
	
	/* Enable PWM clock */
    DrvPWM_Open();  
    
    /* Set PWM pins */
    DrvGPIO_InitFunction(E_FUNC_PWM01);
		DrvGPIO_InitFunction(E_FUNC_PWM23);

    /* PWM Timer property */ 
    sPt.u8Mode = DRVPWM_AUTO_RELOAD_MODE;  //ΪԶسֵģʽ
    sPt.u32Frequency = 1000;     //PWM0Ƶ1K
    sPt.u8HighPulseRatio = 30;   //ռձ30%
    sPt.i32Inverter = 0;         //  
    u8Timer = DRVPWM_TIMER0;     //PWM0
                                
    /* Select PWM engine clock */
    DrvPWM_SelectClockSource(u8Timer, DRVPWM_HCLK);
    
    /* Set PWM Timer0 Configuration */
    DrvPWM_SetTimerClk(u8Timer, &sPt);

    /* Enable Output for PWM Timer0 */
    DrvPWM_SetTimerIO(u8Timer, 1);
		
		/* Enable the PWM Timer 0 */
    DrvPWM_Enable(u8Timer, 1);		
				
		/*--------------------------------------------------------------------------------------*/
		/* Set the PWM Capture 3 for capture function                                           */
		/*--------------------------------------------------------------------------------------*/

		/* PWM Timer property for Capture */ 
		sPt.u8Mode = DRVPWM_AUTO_RELOAD_MODE;
		sPt.u32Frequency = 100;         /* Set the proper frequency to capture data (Less than the input data)*/
		sPt.u8HighPulseRatio = 50;      /* High Pulse peroid : Total Pulse peroid = 50 : 100 (Set a non-zero value) */
		sPt.u32Duty = 0x10000;  //ֵ/* Set the counter to the maximum value */
		sPt.i32Inverter = 0;
		u8CapTimer = DRVPWM_CAP3; //PWM3Ϊͨ

		/* Select PWM engine clock */
		DrvPWM_SelectClockSource(u8CapTimer, DRVPWM_EXT_12M);//ѡⲿ12MʱԴ
		
		/* Set PWM Timer 3 for Capture */
		DrvPWM_SetTimerClk(u8CapTimer, &sPt);
		
		/* Enable Interrupt Sources of PWM Capture3 */
		DrvPWM_EnableInt(u8CapTimer, DRVPWM_CAP_FALLING_INT, NULL);//ʹ½ж
		
		/* Enable Input function for PWM Capture 3 */
		DrvPWM_SetTimerIO(u8CapTimer, 1);
		
		/* Enable the PWM Capture3 */
		DrvPWM_Enable(u8CapTimer, 1);

		/* Capture the Input Waveform Data */
		CalPeriodTime(u8CapTimer);   //㲶ʱ
}

void Test_ADC(void)
{	
    int32_t i32ConversionData;
	
		DrvADC_Open(ADC_SINGLE_END, ADC_SINGLE_OP, 0, EXTERNAL_12MHZ, 1);	
		/* Disable the digital input path */
		DrvGPIO_DisableDigitalInputBit(E_GPA, 0); //رADC0ͨ
		/* Configure the corresponding ADC analog input pin */
		DrvGPIO_InitFunction(E_FUNC_ADC0);  //ʹADC0ܽŹ
								
		DrvADC_SetADCChannel(1);        //ʹADC0ͨ
		while(1)
		{				           
			/* start A/D conversion */
			DrvADC_StartConvert();       

			/* Wait conversion done */
			while(DrvADC_IsConversionDone()==FALSE);
      ADC->ADSR.ADF=1;                           //תɱ־
			i32ConversionData = DrvADC_GetConversionData(0);  //ȡת
			printf("Conversion result: 0x%X (%d)\n\n",  i32ConversionData,	i32ConversionData);
			DrvSYS_Delay(200000);		
		}
}	

void Test_DataFlash(void)
{	
		uint32_t base,Data;
		uint32_t config0; 

		UNLOCKREG();
		SYSCLK->PWRCON.OSC22M_EN = 1;
		DrvSYS_Delay(22);
		SYSCLK->AHBCLK.ISP_EN = 1;
		FMC->ISPCON.ISPEN = 1;

		//һֿ¼ʱú
		//enable data flash for 128K APROM
		DrvFMC_Read(0x300000, &config0);      //Cfg0
		config0 &= ~0x1;                      //ʹFlash,(128Kͺ)
		FMC->ISPCON.CFGUEN = 1;               //ʹISPConfig
		DrvFMC_Erase(0x300000);
		DrvFMC_Write(0x300000, config0);
		DrvFMC_Write(0x300004, 0x1F000);      //úconfigҪλоƬЧ
		//û
		base = DrvFMC_ReadDataFlashBaseAddr();         //һFlashĻַ

		DrvFMC_Erase(base);                         //erase 0x1F000 - 0x1F200
		DrvFMC_Write(base, 0x3333CCCC);         //дһֵַ
		DrvFMC_Write(base+4, 0x55555555);       //дڶ
		DrvFMC_Read(base, &Data);               //һУ
		if(Data!=0x3333CCCC)    
			  printf("DataFlash test fail\n");
		else
			  printf("DataFlash test succeed\n");
}	
/*---------------------------------------------------------------------------------------------------------*/
/* MAIN function                                                                           	   			   */
/*---------------------------------------------------------------------------------------------------------*/

int32_t main()
{		
		/* SYSCLK =>12Mhz*/
		UNLOCKREG();
		DrvSYS_SetOscCtrl(E_SYS_XTL12M,ENABLE);
		DrvSYS_Delay(5000);
		DrvSYS_Open(50000000);
		DrvSYS_Delay(5000);
			
		DrvGPIO_Open(E_GPC, 3, E_IO_OUTPUT);
	
		Test_DataFlash();
			
		Test_TIMER();
		
		Test_PWM_CAP();
		
		Test_ADC();
		
		while(1);	

}	

